#ifndef MPA_ION_BUF_T_H
#define MPA_ION_BUF_T_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "hardware/camera3.h"

    ////////////////////////////////////////////////////////////////////////////////
    // ION BUF
    ////////////////////////////////////////////////////////////////////////////////

#define MPA_ION_BUFFER_MAGIC_NUMBER (0x494F4E42)

    typedef struct mpa_ion_buf_t
    {
        uint32_t magic_number; // Used only when transporting through MPA
        int32_t buffer_id;     // ID of this buffer in the group it was allocated in
        void *vaddress;
        void *uvHead;
        void *meta_address;
        int fd;                 // ion memory file descriptor for fast lookup (reserved for future use)
        uint64_t consumerFlags; // flags used by GBM to allocate this
        camera_image_metadata_t img_meta;
        uint64_t size;
        uint32_t width;
        uint32_t height;
        uint32_t stride;
        uint32_t slice;
        uint32_t format;
        struct gbm_bo *bo;
        buffer_handle_t handle;
        uint32_t reserved1;
        uint32_t reserved2;
        uint32_t reserved3;
        uint32_t reserved4;

#ifdef __cplusplus
        // Constructor for C++ compatibility
        mpa_ion_buf_t()
            : magic_number(0),
              buffer_id(-1),
              vaddress(nullptr),
              fd(-1),
              consumerFlags(0),
              size(0),
              width(0),
              height(0),
              stride(0),
              slice(0),
              format(0),
              reserved1(0),
              reserved2(0),
              reserved3(0),
              reserved4(0) {}
#endif

} __attribute__((packed)) mpa_ion_buf_t;

#ifdef __cplusplus
}
#endif

#endif // MPA_ION_BUF_T_H